#include <stdio.h>
#include <avr/io.h>
#include "app4.h"
#include "app4uart.h"

void UartInit(unsigned int baudrate)
{
  UBRRH=baudrate>>8;
  UBRRL=baudrate;
  UCSRB=((1<<RXEN)|(1<<TXEN));
}

int UartReady(void)
{
  return UCSRA & (1<<RXC);
}

int UartRead(unsigned int timeout)
{
  int tmp=TOMULT;
  while (!(UCSRA&(1<<RXC)))
    {
      if (timeout) 
        if (!--tmp)
          {
            tmp=TOMULT;
            if (!--timeout) return 0;
          }
    }
  tmp=UDR;
  if (tmp=='\r') tmp='\n';
  return tmp;
}

int UartWrite(char c)
{
  if (c=='\n') UartWrite('\r');
  while (!(UCSRA&(1<<UDRE)));
  UDR=c;
  return 0;
}

static int stdUartWrite(char c)
{
  return UartWrite(c);
}

static int stdUartRead(void)
{
  return UartRead(0);
}

void UartSetStdio(void)
{
 fdevopen(stdUartWrite,stdUartRead,0);
}

